/******************************************************************************************************************
 this is my main object for widget
 *******************************************************************************************************************/
var vrWidget = {};
vrWidget.gridTable = {};
vrWidget.gridTable.setDom = {};
vrWidget.gridTable.events = {};






/******************************************************************************************************************
 called when creating the widget
 *******************************************************************************************************************/
vrWidget.gridTable.create = function (params) {
    var sel, v, newGridTable;
    //add scrollTop number to jquery
    jQuery.fn.cssNumber = function (prop) {
        v = parseInt(this.css(prop), 10);
        return isNaN(v) ? 0 : v;
    };


    //add div to my created gridTables
    newGridTable = vrWidget.gridTable[params.div] = {};

    //main buildup
    newGridTable._private = {};
    newGridTable._private.params = {};
    newGridTable._private.functions = {};
    newGridTable._private.params = params;
    newGridTable._private.lastScrollHeight = 0;
    newGridTable.lastKeyKode = "none";
    newGridTable.lastRowSelect = null;
    newGridTable.lastRowScrollTop = null;

    //quick fix selection
    sel = params.source.getSelection();
    if (params.isMultiSelect === true) {
        sel.reset('multiple');
    }


    //this will add header, body, footer
    vrWidget.gridTable.setDom.drawTable(newGridTable);

    //add events
    vrWidget.gridTable.events.addEvents(newGridTable);


    //fill in data:
    vrWidget.gridTable.events.updateRow(newGridTable, true);
};





/******************************************************************************************************************
 called when addmin the main events
 *******************************************************************************************************************/
vrWidget.gridTable.events.addEvents = function (params) {

    //add scroll events
    vrWidget.gridTable.events.addScrollEvent(params);

    //add click events
    vrWidget.gridTable.events.addClickEvent(params);

    //add dragDrop events
    vrWidget.gridTable.events.addDragDropEvent(params);

    //add resize events
    vrWidget.gridTable.events.addResizeHeaderEvent(params);

    //add listners for datasource
    params.events = new vrWidget.gridTable.events.datasourceListners(params);
};


/******************************************************************************************************************
 on datasource events
 *******************************************************************************************************************/
vrWidget.gridTable.events.datasourceListners = function (params) {

    //simple for now

    params._private.params.source.addListener("all", function (e) {

        switch (e.eventKind) {
        case "onCollectionChange":
            vrWidget.gridTable.setDom.setScrollHeight(params);
            vrWidget.gridTable.events.onScrollLoopTables(params);
            break;
        case "onCurrentElementChange":
            vrWidget.gridTable.setDom.setScrollHeight(params);
            vrWidget.gridTable.events.onScrollLoopTables(params);
            break;
        case "onAttributeChange":
            vrWidget.gridTable.setDom.setScrollHeight(params);
            vrWidget.gridTable.events.onScrollLoopTables(params);
            break;
        case "onBeforeCurrentElementChange":
            vrWidget.gridTable.setDom.setScrollHeight(params);
            vrWidget.gridTable.events.onScrollLoopTables(params);
            break;
        case "onElementSaved":
            vrWidget.gridTable.setDom.setScrollHeight(params);
            vrWidget.gridTable.events.onScrollLoopTables(params);
            break;
        }

    });

};

/******************************************************************************************************************
 click events
 *******************************************************************************************************************/
vrWidget.gridTable.events.addClickEvent = function (params) {

    function remove(currentRow) {
        var sel, selectedRows, i;

        function removeNo(array, row) {
            array.splice(row, 1);
        }
        sel = params._private.params.source.getSelection();
        selectedRows = sel.getSelectedRows();
        for (i = 0; i < selectedRows.length; i++) {
            if (selectedRows[i] === currentRow) {
                removeNo(selectedRows, i);
                i--;
            }
        }
        sel.setSelectedRows(selectedRows);
    }


    function clicked(e) {
        var rowHeight, currentRow, sel, thisTop, currentKeyKode, isSel;
        //in case they hit the border...
        if (e.target.className === "cells") {
            thisTop = $(e.target).parent().parent().parent().cssNumber("top");
        } else {
            thisTop = $(e.target).parent().parent().parent().parent().cssNumber("top");
        }

        rowHeight = params.rowHeight;
        currentRow = Math.round(thisTop / rowHeight);
        sel = params._private.params.source.getSelection();
        if (params._private.params.isMultiSelect === true) {
            currentKeyKode = "";
            if (e.shiftKey) {
                currentKeyKode = "shift";
            }
            if (e.ctrlKey) {
                currentKeyKode = "ctrl";
            }
            if (!e.ctrlKey && !e.shiftKey) {
                currentKeyKode = "none";
            }

            if (currentKeyKode === "none") {
                sel.select(currentRow);
            } else {
                if (params.lastKeyKode === "shift" && currentKeyKode === "ctrl") {
                    isSel = sel.isSelected(currentRow);
                    if (isSel === true) {
                        remove(currentRow);
                    } else {
                        sel.select(currentRow, true);
                    }
                } else {
                    if (params.lastKeyKode === "ctrl" && currentKeyKode === "shift") {
                        sel.selectRange(params.lastRowSelect, currentRow);
                    } else {
                        if (params.lastKeyKode === "ctrl" && currentKeyKode === "ctrl") {
                            isSel = sel.isSelected(currentRow);
                            if (isSel === true) {
                                remove(currentRow);
                            } else {
                                sel.select(currentRow, true);
                            }

                        } else {
                            if (params.lastKeyKode === "none" && currentKeyKode === "ctrl") {
                                isSel = sel.isSelected(currentRow);
                                if (isSel === true) {
                                    remove(currentRow);
                                } else {
                                    sel.select(currentRow, true);
                                }
                            } else {
                                if (params.lastKeyKode === "shift" && currentKeyKode === "shift") {
                                    sel.selectRange(params.lastRowSelect, currentRow);
                                } else {
                                    if (params.lastKeyKode === "none" && currentKeyKode === "shift") {
                                        if (params.lastRowSelect !== null) {
                                            sel.selectRange(params.lastRowSelect, currentRow);
                                        } else {
                                            sel.select(currentRow);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        } else {
            sel.select(currentRow);
        }


        params.lastKeyKode = currentKeyKode;
        params.lastRowSelect = currentRow;

        vrWidget.gridTable.events.selectedUpdate(params);
        //so current selected entity get changed on click
        params._private.params.source.select(currentRow, {
            onSuccess: function () {
                //selected

            }
        });
    }

    $(params.ID + " .vr-widget-gridTable-rowAlt").click(function (e) {
        clicked(e);
    });

    $(params.ID + " .vr-widget-gridTable-rowEven").click(function (e) {
        clicked(e);
    });


};

/******************************************************************************************************************
 update selection
 *******************************************************************************************************************/
vrWidget.gridTable.events.selectedUpdate = function (params) {
    var thisTop, rowHeight, currentRow, sel, isSel;

    $(params.ID + " .vr-widget-gridTable-row").each(function (e) {
        thisTop = $(this).cssNumber("top");
        rowHeight = params.rowHeight;
        currentRow = Math.round(thisTop / rowHeight);
        sel = params._private.params.source.getSelection();
        isSel = sel.isSelected(currentRow);
        if (isSel === true) {
            $(this).addClass("vr-widget-gridTable-selected");
        } else {
            $(this).removeClass("vr-widget-gridTable-selected");
        }
    });

};



/******************************************************************************************************************
 dragDrop events
 *******************************************************************************************************************/
vrWidget.gridTable.events.addDragDropEvent = function (params) {
    var divs, i;
    divs = $(params._private.headerClassTable).children().children().children();
    for (i = 0; i < divs.length; i++) {
        //this is the "content" divs, div parent is the "td"
    }

};

/******************************************************************************************************************
 resize Header events
 *******************************************************************************************************************/
vrWidget.gridTable.events.addResizeHeaderEvent = function (params) {
    var i, divs;
    divs = $(params._private.headerClassTable).children().children().children();
    for (i = 0; i < divs.length; i++) {

    }
    //$(".cell-1").css({"width":"233px"});

};

/******************************************************************************************************************
 scroll events
 *******************************************************************************************************************/
vrWidget.gridTable.events.addScrollEvent = function (params) {

    //add scroll event
    $(params._private.bodyClass).scroll(function () {
        vrWidget.gridTable.events.onScroll(params);
        //in scroll event call my "onScroll"
    });
};


/******************************************************************************************************************
 on actual scroll
 *******************************************************************************************************************/
vrWidget.gridTable.events.onScroll = function (params) {

    //get scroll horizontal
    var leftScroll = $(params._private.bodyClass).scrollLeft();

    //set header correct to body
    $(params._private.headerClassTable).parent().css({"position": "relative", "left": "-" + leftScroll + "px", "top": "0px"});

    //do I want to move footer too?
    //maybe add option for footer to scroll, really depends on how you use the footer

    vrWidget.gridTable.events.onScrollLoopTables(params);


};

/******************************************************************************************************************
 on actual scroll, putting code here so it's easier to control
 *******************************************************************************************************************/
vrWidget.gridTable.events.onScrollLoopTables = function (params) {
    var topScroll, lastScroll, rowHeight, isDownScroll, currentRow, newTop, heightAllRows, scrollHeightRows, rowGroup, rowsToChange,
        newHeightDown, newHeightUp, tables, row, ChangedRows, i, currentRowHeight, mustUpdate, maxHeight, sumTop, numCorrection;

    topScroll = $(params._private.bodyClass).scrollTop();
    lastScroll = params._private.lastScrollHeigh;
    rowHeight = params.rowHeight;
    isDownScroll = false;
    if (topScroll >= lastScroll) {
        isDownScroll = true;
    }
    params._private.lastScrollHeigh = topScroll;
    currentRow = Math.round(topScroll / rowHeight);
    newTop = currentRow * rowHeight;
    heightAllRows = (params.createdRows * (rowHeight));
    scrollHeightRows = currentRow * rowHeight;
    rowGroup = Math.floor((newTop / (heightAllRows))) + 1;
    rowsToChange = 0;
    maxHeight = $(params._private.bodyScrollClass).cssNumber("height") - rowHeight;
    if (currentRow > params.createdRows) {
        rowsToChange = currentRow - (params.createdRows * Math.floor(newTop / heightAllRows));
        if(((rowsToChange * rowHeight) + (rowHeight * currentRow)) > maxHeight) {
            sumTop = (rowsToChange * rowHeight) + (rowHeight * currentRow);
            numCorrection = ((maxHeight - sumTop) / rowHeight);
            rowsToChange = rowsToChange - numCorrection;
        }
    } else {
        rowsToChange = currentRow;
    }
    newHeightDown = heightAllRows * rowGroup;
    newHeightUp = heightAllRows * (rowGroup - 1);
    //then I move cells that is hidden down to bottom
    tables = $(params._private.bodyScrollClass).children("table");
    row = 0;
    ChangedRows = 0;
    mustUpdate = 0;
    for (i = 0; i < params.createdRows; i++) {
        //get that bugger away
        if ($(tables[i]).cssNumber("top") > maxHeight) {
            $(tables[i]).css({"top": (0) + "px"});
        }

        if (rowsToChange > ChangedRows) {
            currentRowHeight = $(tables[i]).cssNumber("top");
            if (newHeightDown + (row * rowHeight) < params.scrollHeight) {
                $(tables[i]).css({"top": (newHeightDown + (row * rowHeight)) + "px"});
                if (currentRowHeight !== (newHeightDown + (row * rowHeight))) {
                    vrWidget.gridTable.events.clearCell(tables[i]);
                }
            }
        } else {
            currentRowHeight = $(tables[i]).cssNumber("top");
            if ((newHeightUp + (row * rowHeight)) < maxHeight) {
                $(tables[i]).css({"top": (newHeightUp + (row * rowHeight)) + "px"});
                if (currentRowHeight !== (newHeightUp + (row * rowHeight))) {
                    vrWidget.gridTable.events.clearCell(tables[i]);
                }
            }
        }
        row++;
        ChangedRows++;
    }


    if (params.timer === 0) {
        params.lastRowScrollTop = topScroll;
        params.timer = setTimeout(function () {vrWidget.gridTable.events.updateRow(params, isDownScroll); }, 70);
    } else {
        if (topScroll === 0 || currentRow >= params._private.params.source.length) {
            params.lastRowScrollTop = topScroll;
            params.timer = setTimeout(function () {vrWidget.gridTable.events.updateRow(params, isDownScroll); }, 70);
        }
        //temp fix for wakanda not to mess up when scrolled downed
        if ((newHeightDown + (row * rowHeight)) > (maxHeight - rowGroup)) {
            params.lastRowScrollTop = topScroll;
            params.timer = setTimeout(function () {vrWidget.gridTable.events.updateRow(params, isDownScroll); }, 70);
        }
    }

};

/******************************************************************************************************************
 on grid update
 *******************************************************************************************************************/
vrWidget.gridTable.events.clearCell = function (row) {
    var ii, cells;
    //clear highlight
    $(row).removeClass("vr-widget-gridTable-selected");
    //just clear cell that have been moved
    cells = $(row).children().children().children();
    for (ii = 0; ii < cells.length; ii++) {
        try {
            $(cells[ii])[0].children[0].innerHTML = "";
        } catch (e) {

        }
    }

};



/******************************************************************************************************************
 on grid update
 *******************************************************************************************************************/
vrWidget.gridTable.events.updateRow = function (params, upDownScroll) {

    var rows, topScroll, rowHeight, currentRow, collection;
    //this part wil only buffer it
    rows = $(params._private.bodyScrollClass).children("table");
    topScroll = $(rows[0]).cssNumber("top");
    rowHeight = params.rowHeight;
    currentRow = Math.round(topScroll / rowHeight);
    collection = params._private.params.source.getEntityCollection();

    if (upDownScroll) {
        collection.getEntity(currentRow, {
            onSuccess : function (e) {
                vrWidget.gridTable.events.updateRowCell(params);

            }
        });

    } else {
        //dont wanto send rest call if it's below 0
        if (currentRow >= 0) {
            collection.getEntity((currentRow - 40), {
                onSuccess : function (e) {
                    vrWidget.gridTable.events.updateRowCell(params);
                }
            });
        }

    }

};




/******************************************************************************************************************
 on grid cell
 *******************************************************************************************************************/
vrWidget.gridTable.events.updateRowCell = function (params, tableRow) {

    var rows, topScroll, rowHeight, currentRow, collection, cells, attr, value, i, ii, lastScroll, isDownScroll;


    rows = $(params._private.bodyScrollClass).children("table");
    for (i = 0; i < rows.length; i++) {
        //just thinking on how to do it..
        topScroll = $(rows[i]).cssNumber("top");
        rowHeight = params.rowHeight;
        currentRow = Math.round(topScroll / rowHeight);
        //currentRow = Math.floor(topScroll / rowHeight);
        collection = params._private.params.source.getEntityCollection();
        cells = $(rows[i]).children().children().children();
        collection.getEntity(currentRow, {
            onSuccess : function (e) {
                for (ii = 0; ii < cells.length; ii++) {
                    try {
                        attr = $($(cells[ii])[0].children[0]).attr("attribute");
                        if (e.entity[attr] === undefined) {
                            $(cells[ii])[0].children[0].innerHTML = "";
                        } else {
                            value = e.entity[attr].value;  //this will kill, set cell to blank then this fail..
                            if (value === undefined || value === null) {
                                value = "";
                            }
                            $(cells[ii])[0].children[0].innerHTML = value;
                            params._private.params.onCellBodyRender($(cells[ii])[0].children[0], attr, value, e.entity);
                        }
                    } catch (error) {


                    }
                }
            }
        });


    }
    vrWidget.gridTable.events.selectedUpdate(params);



    //here we wanna check scroll, if it's change then update again
    topScroll = $(params._private.bodyClass).scrollTop();
    lastScroll = params._private.lastScrollHeigh;
    if (params.lastRowScrollTop !== topScroll) {
        params.timer = 0;
        vrWidget.gridTable.events.onScrollLoopTables(params);

    } else {
        params.timer = 0;
    }


};







/******************************************************************************************************************
 drawing of the table in div we want it in
 *******************************************************************************************************************/
vrWidget.gridTable.setDom.drawTable = function (params) {

    params.ID = params._private.params.div;
    params._private.headerClassTable = params._private.params.div + " .vr-widget-gridTable-Header table tbody";
    params._private.bodyClass = params._private.params.div + " .vr-widget-gridTable-body";
    params._private.bodyScrollClass = params._private.params.div + " .vr-widget-gridTable-bodyScroll";
    params._private.footerClassTable = params._private.params.div + " .vr-widget-gridTable-footer table tbody";
    params.timer = 0;

    //clear what ever is in the div
    $(params.div).html("");

    //adds the main dom to div
    vrWidget.gridTable.setDom.addMainDom(params);

    //adds headertemplate
    vrWidget.gridTable.setDom.addHeaderTemplate(params);

    //add footer template
    vrWidget.gridTable.setDom.addFooterTemplate(params);

    //setBody height- header - footer
    vrWidget.gridTable.setDom.setBodyHeight(params);


    //add body tables, body will consist of many tables with just 1 body template inside.
    //this should only add basic parts needed for empty grid, like a "design" part, that should make it easier to redo to widgets later
    vrWidget.gridTable.setDom.addBodyTemplate(params);

    //this will calculate scrollHeight, so it can be called when adding entities or removing them
    vrWidget.gridTable.setDom.setScrollHeight(params);

};


/******************************************************************************************************************
 sets the correct body "scroll" height
 *******************************************************************************************************************/
vrWidget.gridTable.setDom.setScrollHeight = function (params) {
    var rowHeight, entities, totalHeight;
    rowHeight = (params._private.params.singleBodyRowHeight + params._private.params.singelBodyRowHeightBorder) * params._private.params.templateBodyRows;
    entities = params._private.params.source.length;
    totalHeight = rowHeight * entities;

    $(params._private.bodyScrollClass).css({"height" : (totalHeight + 2) + "px"});
    params.scrollHeight = totalHeight;


};



/******************************************************************************************************************
 sets the body height
 *******************************************************************************************************************/
vrWidget.gridTable.setDom.setBodyHeight = function (params) {
    var headerHeight, footerHeight, totalFooterHeaderHeight, MainDivHeight, bodyHeight;

    headerHeight = $(params._private.params.div + " .vr-widget-gridTable-Header table").height();
    footerHeight = $(params._private.params.div + " .vr-widget-gridTable-Header table").height();
    totalFooterHeaderHeight = headerHeight + footerHeight;
    MainDivHeight = $(params._private.params.div).height();
    bodyHeight = MainDivHeight - totalFooterHeaderHeight;
    params.bodyHeigth = bodyHeight;
    $(params._private.bodyClass).css({"height" : bodyHeight + "px"});


};





/******************************************************************************************************************
 add footer to main body
 *******************************************************************************************************************/
vrWidget.gridTable.setDom.addFooterTemplate = function (params) {
    var footerTemplate, divId, rowHeight, currentSetting, i, cells;
    footerTemplate = $(params._private.params.templateFooterRow);

    divId = params.ID;
    rowHeight = params._private.params.singleFooterRowHeight;
    i = 0;

    //for each cell, and content div, and etc settings
    cells = $(footerTemplate).children("td").each(function () {
        currentSetting = params._private.params.cellAttributesFooter[i];
        $(this).addClass(" cells ");
        this.innerHTML = "<div class='vr-widget-gridTable-content cell-" + i + " ' style='width:" + currentSetting.width + "px; height:" + rowHeight + "px'>" + currentSetting.attributeHeader + "</div>";
        i++;
    });
    // now we just add it
    $(params._private.footerClassTable).append(footerTemplate);

};







/******************************************************************************************************************
 add body to main body
 *******************************************************************************************************************/
vrWidget.gridTable.setDom.addBodyTemplate = function (params) {
    var divId, rowsNeeded, rowHeight, realRowHeight, i, bodyTemplate, bodyTemplateRow, currentSetting, c, cells, table, newTop;
    divId = params.ID;
    rowsNeeded = Math.floor(params.bodyHeigth / (params._private.params.singleBodyRowHeight * params._private.params.templateBodyRows)) + 6;
    rowHeight = params._private.params.singleBodyRowHeight;
    realRowHeight = params._private.params.singleBodyRowHeight + params._private.params.singelBodyRowHeightBorder;


    params.rowHeight = (realRowHeight) * params._private.params.templateBodyRows;
    //set rows to params
    params.createdRows = rowsNeeded;



    bodyTemplate = "";
    bodyTemplateRow = [];
    for (i = 0; i < rowsNeeded; i++) {
        bodyTemplate = $(params._private.params.templateBodyRow);
        c = 0;
        //for each cell, and content div, and etc settings
        cells = $(bodyTemplate).children("td").each(function () {
            currentSetting = params._private.params.cellAttributesBody[c];
            $(this).addClass(" cells ");
            this.innerHTML = "<div class='vr-widget-gridTable-content cell-" + c + "' attribute=" + currentSetting.attributeName + " style='width:" + currentSetting.width + "px; height:" + rowHeight + "px'>" + i + "</div>";
            c++;
        });
        bodyTemplateRow.push(bodyTemplate);
    }


    //temp table
    table = [];
    newTop = 0;
    for (i = 0; i < rowsNeeded; i++) {
        table.push($("<table class='vr-widget-gridTable-row'' style='position: absolute; left: 0px; top: " + newTop + "px;'><tbody></tbody></table>"));

        //add alt class
        if (i % 2 === 1) {
            $(table[i]).addClass("vr-widget-gridTable-rowAlt");
        } else {
            $(table[i]).addClass("vr-widget-gridTable-rowEven");
        }

        $(table[i]).append(bodyTemplateRow[i]);
        newTop = newTop + params.rowHeight;
    }
    //add a lots of tables
    for (i = 0; i < rowsNeeded; i++) {
        $(params._private.bodyScrollClass).append(table[i]);
    }


};





/******************************************************************************************************************
 main body for header/body/footer
 *******************************************************************************************************************/
vrWidget.gridTable.setDom.addMainDom = function (params) {
    var id, gridContent;
    //get main div from params
    id = params.ID;

    //main content, not bothering about using jquery looping abd building it up, this is easier for me.
    gridContent = "<div class='" + "vr-widget" + "'>" +
        "<div class='vr-widget-gridTable-Header'>" +
        "<table style='position: relative; left: 0px; bottom: 0px;'>" +
        "<tbody>" +
        "</tbody>" +
        "</table>" +
        "</div>" +
        "<div class='vr-widget-gridTable-body'>" +
        "<div class='vr-widget-gridTable-bodyScroll' style='height: 0px;'>" +
        "</div>" +
        "</div>"+
        "<div class='vr-widget-gridTable-footer'>" +
        "<table style='position: relative; left: 0px; bottom: 0px;'>" +
        "<tbody>" +
        "</tbody>" +
        "</table>" +
        "</div>" +
        "</div>";

    //add it to the grid
    $(id).append(gridContent);

};






/******************************************************************************************************************
 add header to main body
 *******************************************************************************************************************/
vrWidget.gridTable.setDom.addHeaderTemplate = function (params) {
    var headerTemplate, divId, rowHeight, i, currentSetting;
    //get the header template
    headerTemplate = $(params._private.params.templateHeaderRow);
    divId = params.ID;
    rowHeight = params._private.params.singleHeaderRowHeight;


    i = 0;
    //for each cell, and content div, and etc settings
    cells = $(headerTemplate).children("td").each(function () {
        currentSetting = params._private.params.cellAttributesHeader[i];
        $(this).addClass(" cells " + "cell-" + i);

        this.innerHTML = "<div  class='cellContent" + i + " vr-widget-gridTable-content cell-" + i + "' style='width:" + currentSetting.width + "px; height:" + rowHeight + "px'>" + currentSetting.attributeHeader + "</div>";
        i++;
    });

    // now we just add it
    $(params._private.headerClassTable).append(headerTemplate);

};






